/**
 * @file tpylo.cpp
 * @brief 全体プログラム
 * @author 岡部
 * @date 2020/11/11
 */

#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

#include "alternate.hpp"
#include "arduino.h"
#include "io.hpp"
#include "straw.hpp"
#include "sock.h"


int main(){
    Alternate sw_pw(7, false);
    Io sw_ad(6, false);
	Straw straw;

	pthread_t thread;
	pthread_create(&thread, NULL, (void *(*)(void *))&connectPython, NULL);
	pthread_detach(thread);

	if(arduino_open() != 0) return -1;
	puts("Tpylo Start!");
	sleep(1);

	while(true){
        G_audio = (int)sw_ad.getSw();
        if(sw_pw.getSw()){
            G_state = 5;
            straw.update();
        }
        else G_state = 0;
		usleep(1000);
	}
	return 0;
}
